let relative = ./local.dhall
in

let Product = { first : Text, second : Optional (List Integer) }
in

let atVar =
  λ(x : Type) → λ(x : Type) → x@0
in

let Sum = < Tag : Text | IntTag : Integer >
in

let ConstructorSum = constructors < None : {} | Some : Integer >
in

let quotedRecord = 
  { `Field` = 2 }
in

let constructorExpression =
  ConstructorSum.None {=}
in

let doubleLit = 2.234329
in

let boolLit = False
in

let intLit = -121
in

let natLit = +223
in

let string =
  "string"
in

let typedFunction : ∀(x : Integer) → Integer =
  λ(x : Integer) → x
in

let plebTypedFunctions : forall (x : Integer) -> Integer =
  \(x : Integer) -> x
in

let list =
  [0,1,2]
in

let option =
  [ "tag" ] : Optional Text
in

let record =
  { first = "text", second = [ list ] : Optional (List Integer) } : Product
in

let sumValue =
  < Tag : {} | IntTag = 2 >
in

let update = 
  record // { isSpecial = True }
in

let escapedStr =
  "escape\""
in

let uUpdate =
  record ⫽ { isSpecial = True }
in

let squish =
  record /\ { isSpecial = True }
in

let uSquish =
  record ∧ { isSpecial = True }
in

let tuple =
  { _1 = True, _2 = "false" }
in

let multExpr =
  +3 * +4
in

let duplicateString =
  λ(x : Text) → x ++ x
in

let simpleSplice =
  "something ${update.first}"
in

let fancySplice =
  "fancy ${duplicateString simpleSplice} status:${relative}"
in

let spliceSpecial =
  "${fancySplice} @#$%#$@$"
in

spliceSpecial
